#include "stdafx.h"
#include "EventMidi.h"
#include "MusicStudioFileFormat.h"

extern DUR DurTab[0x15];

CEventMidi::CEventMidi()
{
    ///-----------------------------------
    /// Initialized data membbers
    ///-----------------------------------
	m_pNext = 0;
	m_pPrev = 0;
}

CEventMidi::~CEventMidi()
{
    //dtor
}

int CEventMidi::DecTicks(void)
{
	///----------------------------
	/// Real time ticker
	///----------------------------
    int rV=0;
    m_Ticks--;	///decrement ticker
    ///----------------------------
    /// if the ticker is within a
    /// count of two, indicate this
    /// by return the value two
    ///----------------------------
    if(m_Ticks == 2)
        rV = 2;
	///----------------------------
	/// If the ticker is 0, we have
	/// run out of time.  Return 1
	/// to indicate this.
	///----------------------------
    else if(m_Ticks == 0)
        rV = 1;
	///----------------------------
	/// Elese, just return 0
	///----------------------------
    return rV;
}

void CEventMidi::SetTick(int Duration, int tempo)
{
	///----------------------------
	/// Set the number of ticks for
	/// the ticker.  This is the
	/// product of the duration
	/// and the tempo
	///----------------------------
    m_Ticks = DurTab[Duration].Dur * tempo;
	if(m_Ticks < 2)
		m_Ticks = 3;
}

void CEventMidi::Print(FILE *pO)
{
	///for debug
	fprintf(pO,"Ticks = %d\n",m_Ticks);
}

int CEventMidi::GetChannel()
{
	///------------------------------------------
	///	GetChannel
	///		Returns the Midi Channel number for
	///	the note that is going to play.
	///------------------------------------------
	return GetNote()->m_pMidiInfo->GetChannel(m_pNote->GetTrack());
}
