///-------------------------------------------------
/// MidiInProc
///-------------------------------------------------

void CALLBACK MidiInProc(HMIDIIN hMidiIn,UINT wMsg,DWORD dwInst,DWORD dwP1,DWORD dwP2)
{
	CMSPlayerDlg *pDlg = (CMSPlayerDlg *)dwInst;
	switch(wMsg)
	{
		case MIM_CLOSE:
			break;
		case MIM_DATA:
			pDlg->PostMessage(WM_MIDIIN,dwP1,dwP2);
			break;
		case MIM_ERROR:
			break;
		case MIM_LONGDATA:
			{
				MIDIHDR *pMHdr = (MIDIHDR *)dwP1;
			}
			break;
		case MIM_LONGERROR:
			break;
		case MIM_MOREDATA:
			break;
		case MIM_OPEN:
			break;
	}
}

void CMSPlayerDlg::OnMenuSetupSelmidi()
{
	// TODO: Add your command handler code here
	CSelectMidi Dlg;
	UINT MidiOutIndex,MidiInIndex;

	if(Dlg.DoModal() == IDOK)
	{
		MidiOutIndex = Dlg.MidiOutIndex;
		MidiInIndex = Dlg.MidiInIndex;
		if(midiInOpen(&m_hMidiIn,MidiInIndex,(DWORD)MidiInProc,(DWORD)this,CALLBACK_FUNCTION) == MMSYSERR_NOERROR)
		{
			m_MidiInFlag = 1;
			//----------------------------
			// create a pair of midi in
			// buffers
			//-----------------------------
			midiInPrepareHeader(m_hMidiIn,&this->m_MidiIn1,sizeof(MIDIHDR));
			midiInPrepareHeader(m_hMidiIn,&this->m_MidiIn2,sizeof(MIDIHDR));
			m_MidiIn1.lpData = new char[4096];
			m_MidiIn2.lpData = new char[4096];
			m_MidiIn1.dwBufferLength = 4096;
			m_MidiIn2.dwBufferLength = 4096;
			midiInStart(m_hMidiIn);
		}
		else
		{
			MessageBox("Could Not Open Midi In","ERROR");
		}
		if(midiOutOpen(&m_hMidiOut,MidiOutIndex,0,0,0) == MMSYSERR_NOERROR)
		{
			m_MidiOutFlag = 1;
		}
		else
		{
			MessageBox("Could Not Open Midi Out","ERROR");
		}
	}
}

LRESULT CMSPlayerDlg::OnMidiInMsg(WPARAM wMsg, LPARAM timestamp)
{
	int Cmd;
	int Vel;
	int Note;
	int Chan;
	char *s = new char[256];

	Cmd = wMsg & 0xf0;
	Chan = wMsg & 0x0f;
	Note = (wMsg & 0x0ff00) >> 8;
	Vel = (wMsg & 0x0ff0000) >> 16;
	switch(Cmd)
	{
		case MIDI_NOTEOFF:
			sprintf(s,"NOTE OFF:Chan=%d Vel=%d Note=%d",Chan,Vel,Note);
			this->m_Static_Message.SetWindowText(s);
			break;
		case MIDI_NOTEON:
			sprintf(s,"NOTE ON:Chan=%d Vel=%d Note=%d",Chan,Vel,Note);
			this->m_Static_Message.SetWindowText(s);
			break;
		case MIDI_PGMCHANGE:
			break;
		case MIDI_CLOCK:
			break;
		case MIDI_START:
			break;
		case MIDI_STOP:
			break;
		case MIDI_CONTINUE:
			break;
	}
	delete[] s;
	return 0;
}

