// MSPlayerDlg.h : header file
//

#if !defined(AFX_MSPLAYERDLG_H__D9E94D83_F558_4A69_88F8_3FCC73D7B364__INCLUDED_)
#define AFX_MSPLAYERDLG_H__D9E94D83_F558_4A69_88F8_3FCC73D7B364__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <mmsystem.h>
#include "MsSong.h"
#include "TrackColors.h"
#include "DisplayStatic.h"
#include "HorzScrollBar.h"
#include "StaffView.h"
#include "StaticStatus.h"
#include "afxwin.h"
#include "ComboBitmap.h"
#include "MyComboBox.h"

/////////////////////////////////////////////////////////////////////////////
// CMSPlayerDlg dialog

#define COMBO_DECOR_ACCENT		0
#define COMBO_DECOR_NONE		1
#define COMBO_DECOR_DOT			2
#define COMBO_DECOR_TRIPLET		3

class CMsTimeSig;

class CMSPlayerDlg : public CDialog
{
	friend CMsTimeSig;
	friend class CMsStaffView;

	//-------------------------------------
	// Note section params for Combo Boxes
	//-------------------------------------
	unsigned short m_NoteDur;
	unsigned short m_NoteTrack;
	unsigned short m_NoteAccent;
	unsigned short m_NoteDotted;
	unsigned short m_NoteTriplet;
	unsigned short m_RestDur;
	unsigned short m_NoteRest;
	unsigned short m_NoteKey;
	unsigned short m_KeySig;
	unsigned short m_TimeSig;
public:
	//---------------------
	// Misc
	//---------------------
	CBitmap m_BmTie;
	CBitmap m_BmBar;
	CBitmap m_BmInstChange;
	CBitmap m_BmTempo;
	CBitmap m_BmLoudness;
	//---------------------
	// Time Signatures
	//---------------------
	CBitmap m_BmTime22;
	CBitmap m_BmTime32;
	CBitmap m_BmTime24;
	CBitmap m_BmTime34;
	CBitmap m_BmTime44;
	CBitmap m_BmTime54;
	CBitmap m_BmTime68;
	//-------------------------------------
	// Instrument Bitmaps
	//------------------------------------
	CBitmap m_BmInst1;
	CBitmap m_BmInst2;
	CBitmap m_BmInst3;
	CBitmap m_BmInst4;
	CBitmap m_BmInst5;
	CBitmap m_BmInst6;
	CBitmap m_BmInst7;
	CBitmap m_BmInst8;
	CBitmap m_BmInst9;
	CBitmap m_BmInst10;
	CBitmap m_BmInst11;
	CBitmap m_BmInst12;
	CBitmap m_BmInst13;
	CBitmap m_BmInst14;
	CBitmap m_BmInst15;
	//---------------------
	// Accidentals
	//---------------------
	CBitmap m_BmInKey;
	CBitmap m_BmSharp;
	CBitmap m_BmFlat;
	CBitmap m_BmNatural;

	//---------------------
	// Block Op Graphics
	//---------------------
	CBitmap m_BmBlockCopy;
	CBitmap m_BmBlockMove;
	CBitmap m_BmBlockChngInst;
	CBitmap m_BmBlockChngDur;
	CBitmap m_BlockIncrDur;
	CBitmap m_BlockDecDur;
	CBitmap m_BlockTransUp;
	CBitmap m_BlockTransDown;
	CBitmap m_BlockRepeat;
	CBitmap m_BlockInsert;
	CBitmap m_BlockMidiInput;

	//--------------
	// NOTE graphics
	//--------------
	CBitmap m_BmWhole;
	CBitmap m_BmHalf;
	CBitmap m_BmQuarter;
	CBitmap m_BmEigth;
	CBitmap m_BmSixteenth;
	CBitmap m_BmThirtysec;
	//----------------
	// Rest Graphics
	//----------------
	CBitmap m_BmWholeRest;
	CBitmap m_BmHalfRest;
	CBitmap m_BmQuarterRest;
	CBitmap m_BmEigthRest;
	CBitmap m_BmSixteenthRest;
	CBitmap m_BmThirtySecRest;
	//---------------------
	// Decorations
	//---------------------
	CBitmap m_BmAccent;
	CBitmap m_BmNone;
	CBitmap m_BmDot;
	CBitmap m_BmTripplet;
	//---------------------
	CMsKeySignature m_MsKeySig;
// Construction
public:
	afx_msg void OnButtonStop();
	afx_msg void OnButtonPlay();
	LRESULT OnMidiInLongMsg(WPARAM wp, LPARAM timestamp);
	MIDIHDR m_MidiIn2;
	MIDIHDR m_MidiIn1;
	int m_MidiInFlag;
	HMIDIIN m_hMidiIn;
	CStaffView *m_pStaffView;
	void ChangePatch(int chan, int patch);
	long CreateNoteMessageWord(void);
	int m_MaxEvents;
	int m_MidiOutFlag;
	HMIDIOUT m_hMidiOut;
	unsigned m_TimerID;
//	CTrackColors *m_pTrackColors[15];
	CMsSong * m_pSong;
	char * m_pRawSongData;
	CMSPlayerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMSPlayerDlg)
	enum { IDD = IDD_MUSICSTUDIOPLAYER_DIALOG };
	CStaticStatus	m_Static_DisplayStatus;
	CStatic	m_Static_Tempo;
	CHorzScrollBar	m_ScrollBar_Tempo;
	CStatic	m_Static_Loudness;
	CHorzScrollBar	m_ScrollBar_Loudness;
	CComboBox	m_Combo_KeySig;
	CMyComboBox	m_Combo_TimeSig;
	CMyComboBox	m_Combo_Instrument;
	CMyComboBox	m_Combo_TieBar;
	CMyComboBox	m_Combo_Rests;
	CMyComboBox	m_Combo_BlockOps;
	CMyComboBox	m_Combo_Accident;
	CMyComboBox	m_Combo_NoteType;
	CComboBitmap m_Combo_Decorations;
	CDisplayStatic	m_Static_Message;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMSPlayerDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	LRESULT OnMidiInMsg(WPARAM wMsg,LPARAM timestamp);
	HICON m_hIcon;
	LRESULT OnMsgPlay(WPARAM wp, LPARAM lp);
	LRESULT OnPgmChange(WPARAM wp, LPARAM lp);

	// Generated message map functions
	//{{AFX_MSG(CMSPlayerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileOpen();
	afx_msg void OnFmenuFileExit();
	afx_msg void OnMenuFilePlay();
	afx_msg void OnMenuSetupMidi();
	afx_msg void OnMenuSetupSelmidi();
	virtual void OnOK();
	afx_msg void OnSelchangeComboAccident();
	afx_msg void OnSelchangeComboBlockops();
	afx_msg void OnSelchangeComboDecorations();
	afx_msg void OnSelchangeComboInstrument();
	afx_msg void OnSelchangeComboNotemenu();
	afx_msg void OnSelchangeComboRest();
	afx_msg void OnSelchangeComboTiebar();
	afx_msg void OnFileNew();
	afx_msg void OnFileSaveas();
	afx_msg void OnFileSave();
	afx_msg void OnSelchangeComboKeysig();
	afx_msg void OnSelchangeComboTimesig();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileDump();
	CButton m_Button_Play;
	// This function is used to update the combo box selection variables.
	void UpdateComboBoxes();
	FILE *m_pLog;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MSPLAYERDLG_H__D9E94D83_F558_4A69_88F8_3FCC73D7B364__INCLUDED_)
