// MidiConfig.cpp : implementation file
///-----------------------------------
/// This is the implementation of the
/// Midi configuration dialog box
///
///-----------------------------------

#include "stdafx.h"
#include <string.h>
#include "MusicStudioPlayer.h"
#include "MidiConfig.h"
#include "WindowMessages.h"

extern char *GenMidPatchNames[];

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMidiConfig dialog

int octave[6] = {0,-24,-12,0,12,24};

CMidiConfig::CMidiConfig(CWnd* pParent /*=NULL*/)
	: CDialog(CMidiConfig::IDD, pParent)
{
	m_pWndPgmChange = 0;
	//{{AFX_DATA_INIT(CMidiConfig)
	//}}AFX_DATA_INIT
}


void CMidiConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMidiConfig)
	DDX_Control(pDX, IDC_STATIC_MC_BM9, m_Static_Bm9);
	DDX_Control(pDX, IDC_STATIC_MC_BM8, m_Static_Bm8);
	DDX_Control(pDX, IDC_STATIC_MC_BM7, m_Static_Bm7);
	DDX_Control(pDX, IDC_STATIC_MC_BM6, m_Static_Bm6);
	DDX_Control(pDX, IDC_STATIC_MC_BM5, m_Static_Bm5);
	DDX_Control(pDX, IDC_STATIC_MC_BM4, m_Static_Bm4);
	DDX_Control(pDX, IDC_STATIC_MC_BM3, m_Static_Bm3);
	DDX_Control(pDX, IDC_STATIC_MC_BM2, m_Static_Bm2);
	DDX_Control(pDX, IDC_STATIC_MC_BM15, m_Static_Bm15);
	DDX_Control(pDX, IDC_STATIC_MC_BM14, m_Static_Bm14);
	DDX_Control(pDX, IDC_STATIC_MC_BM13, m_Static_Bm13);
	DDX_Control(pDX, IDC_STATIC_MC_BM12, m_Static_Bm12);
	DDX_Control(pDX, IDC_STATIC_MC_BM11, m_Static_Bm11);
	DDX_Control(pDX, IDC_STATIC_MC_BM10, m_Static_Bm10);
	DDX_Control(pDX, IDC_STATIC_MC_BM1, m_Static_Bm1);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE15, m_Static_Range15);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE14, m_Static_Range14);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE13, m_Static_Range13);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE12, m_Static_Range12);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE11, m_Static_Range11);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE10, m_Static_Range10);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE9, m_Static_Range9);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE8, m_Static_Range8);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE7, m_Static_Range7);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE6, m_Static_Range6);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE5, m_Static_Range5);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE4, m_Static_Range4);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE3, m_Static_Range3);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE2, m_Static_Range2);
	DDX_Control(pDX, IDC_STATIC_MIDI_RANGE1, m_Static_Range1);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH15, m_Static_Patch15);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH14, m_Static_Patch14);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH13, m_Static_Patch13);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH12, m_Static_Patch12);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH11, m_Static_Patch11);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH10, m_Static_Patch10);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH9, m_Static_Patch9);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH8, m_Static_Patch8);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH7, m_Static_Patch7);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH6, m_Static_Patch6);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH5, m_Static_Patch5);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH4, m_Static_Patch4);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH3, m_Static_Patcjh3);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH2, m_Static_Patch2);
	DDX_Control(pDX, IDC_STATIC_MIDI_PATCH1, m_Static_Patch1);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN15, m_Static_Chan15);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN14, m_Static_Chan14);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN13, m_Static_Chan13);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN12, m_Static_Chan12);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN11, m_Static_Chan11);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN10, m_Static_Chan10);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN9, m_Static_Chan9);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN8, m_Static_Chan8);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN7, m_Static_Chan7);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN6, m_Static_Chan6);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN5, m_Static_Chan5);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN4, m_Static_Chan4);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN3, m_Static_Chan3);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN2, m_Static_Chan2);
	DDX_Control(pDX, IDC_STATIC_MIDI_CHAN1, m_Static_Chan1);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE15, m_SB_Range15);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE14, m_SB_Range14);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE13, m_SB_Range13);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE12, m_SB_Range12);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE11, m_SB_Range11);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE10, m_SB_Rang10);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE9, m_SB_Range9);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE8, m_SB_Range8);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE7, m_SB_Range7);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE6, m_SB_Range6);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE5, m_SB_Range5);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE4, m_SB_Range4);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE3, m_SB_Range3);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE2, m_SB_Range2);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_RANGE1, m_SB_Range1);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH15, m_SB_Patch15);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH14, m_SB_Patch14);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH13, m_SB_Patch13);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH12, m_SB_Patch12);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH11, m_SB_Patch11);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH10, m_SB_Patch10);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH9, m_SB_Patch9);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH8, m_SB_Patch8);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH7, m_SB_Patch7);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH6, m_SB_Patch6);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH5, m_SB_Patch5);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH4, m_SB_Patch4);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH3, m_SB_Patch3);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH2, m_SB_Patch2);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_PATCH1, m_SB_Patch1);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN15, m_SB_Chan15);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN14, m_SB_Chan14);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN13, m_SB_Chan13);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN12, m_SB_Chan12);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN11, m_SB_Chan11);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN10, m_SB_Chan10);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN9, m_SB_Chan9);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN8, m_SB_Chan8);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN7, m_SB_Chan7);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN6, m_SB_Chan6);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN5, m_SB_Chan5);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN4, m_SB_Chan4);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN3, m_SB_Chan3);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN2, m_SB_Chan2);
	DDX_Control(pDX, IDC_SCROLLBAR_MIDI_CHAN1, m_SB_Chan1);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN15, m_CheckBox_En15);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN14, m_CheckBox_En14);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN13, m_CheckBox_En13);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN12, m_CheckBox_En12);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN11, m_CheckBox_En11);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN10, m_CheckBox_En10);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN9, m_CheckBox_En9);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN8, m_CheckBox_En8);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN7, m_CheckBox_En7);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN6, m_CheckBox_En6);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN5, m_CheckBox_En5);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN4, m_CheckBox_En4);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN3, m_CheckBox_En3);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN2, m_CheckBox_En2);
	DDX_Control(pDX, IDC_CHECK_MIDI_EN1, m_CheckBox_En1);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST15, m_Edit_Inst15);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST14, m_Edit_Inst14);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST13, m_Edit_Inst13);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST12, m_Edit_Inst12);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST11, m_Edit_Inst11);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST10, m_Edit_Inst10);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST9, m_Edit_Inst9);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST8, m_Edit_Inst8);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST7, m_Edit_Inst7);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST6, m_Edit_Inst6);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST5, m_Edit_Inst5);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST4, m_Edit_Inst4);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST3, m_Edit_Inst3);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST2, m_Edit_Inst2);
	DDX_Control(pDX, IDC_EDIT_MIDI_INST1, m_Edit_Inst1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMidiConfig, CDialog)
	//{{AFX_MSG_MAP(CMidiConfig)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN1, OnCheckMidiEn1)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN2, OnCheckMidiEn2)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN3, OnCheckMidiEn3)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN4, OnCheckMidiEn4)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN5, OnCheckMidiEn5)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN6, OnCheckMidiEn6)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN7, OnCheckMidiEn7)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN8, OnCheckMidiEn8)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN9, OnCheckMidiEn9)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN10, OnCheckMidiEn10)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN11, OnCheckMidiEn11)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN12, OnCheckMidiEn12)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN13, OnCheckMidiEn13)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN14, OnCheckMidiEn14)
	ON_BN_CLICKED(IDC_CHECK_MIDI_EN15, OnCheckMidiEn15)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_CHANCHANGE,OnChannelChanged)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMidiConfig message handlers

void InstEditDispFunc(void *p,char *s,int l,int v,int inst)
{
	///------------------------------
	///	InstEditDispFunc
	///		This is the callback
	///	function for the CHorzScrollBar
	///	class for the Instrument
	///	selection.
	///
	/// parameters:
	///		p....pointer to CMidiInfo
	///		s....not ussed (point to char array to put string
	///		l....size of s (not used)
	///		v....value to print (not used)
	///		inst.Instrument index
	///------------------------------
	CMidiInfo *pMI = (CMidiInfo *)p;
	int chan = pMI->GetChannel(inst);
	if(chan == 9)
		pMI->SetInstName(inst,"Percussion");
	else
		pMI->SetInstName(inst,GenMidPatchNames[v]);
	strcpy(s,pMI->GetName(inst));	///FIXME?
}

void ChanDispFunc(void *p,char *s,int l,int v,int inst)
{
	///------------------------------
	///	ChanDispFunc
	///		This is the callback
	///	function for the CHorzScrollBar
	///	class for the Midi Channel
	///	selection.
	///
	/// parameters:
	///		p....pointer(NOT USED)
	///		s....point to char array to put string
	///		l....size of s (not used)
	///		v....value to print
	///		inst.Instrument index(NOT USED)
	///------------------------------
	sprintf_s(s,l,"%d",v+1);
}

BOOL CMidiConfig::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	//--------------------------------
	// Initialize all of the sliders
	//--------------------------------
	/// We are going to setup
	/// pointers to the arrays
	/// of control objects.
	///---------------------------
	CStatic *pRange = &m_Static_Range1;
	CStatic *pPatch = &m_Static_Patch1;
	CStatic *pChan = &m_Static_Chan1;
	CHorzScrollBar *pSBRange = &m_SB_Range1;
	CHorzScrollBar *pSBPatch = &m_SB_Patch1;
	CHorzScrollBar *pSBChan = &m_SB_Chan1;
	CButton *pCB = &m_CheckBox_En1;
	CStaticBitmap *pBm = &m_Static_Bm1;
	m_ppInstName = &m_Edit_Inst1;

	int i;
	///------------------------------
	/// Setup all the controls in the
	/// box.
	///------------------------------
	for(i=0;i<15;++i)
	{
		//to get instrument number, add 1 to i
		pCB->SetCheck(m_pSong->GetMidiInfo()->IsTrackEnable(0,i+1));
		--pCB;
		pBm->SetColor(m_pSong->GetMidiInfo()->GetInstColor(i+1)->GetColor() );
		--pBm;

		pSBRange->SetScrollRange(0,6);
		pSBRange->SetDisplayText(pRange);
		pSBRange->SetScrollPos(m_pSong->GetMidiInfo()->GetRange(i+1));
		pSBRange->SetShortMasterValue(m_pSong->GetMidiInfo()->GetRangeRef(i+1));
		--pSBRange;
		--pRange;
		pSBPatch->SetScrollRange(0,127);
		pSBPatch->SetDisplayText(pPatch);
		pSBPatch->SetFormatParam(m_pSong->GetMidiInfo(),i+1);
		pSBPatch->SetDisplayEdit(m_ppInstName);
		pSBPatch->SetEditDisplayFormatFunction(InstEditDispFunc);
		pSBPatch->SetActionMessage(m_pWndPgmChange,WM_PGMCHANGE,i+1);
		pSBPatch->SetShortMasterValue(m_pSong->GetMidiInfo()->GetPatchRef(i+1));
		pSBPatch->SetScrollPos(m_pSong->GetMidiInfo()->GetPatch(i+1));
		--pSBPatch;
		--pPatch;
		pSBChan->SetScrollRange(0,15);
		pSBChan->SetDisplayText(pChan);
		pSBChan->SetDisplayFormatFunction(ChanDispFunc);
		pSBChan->SetActionMessage(this,WM_CHANCHANGE,i+1);
		pSBChan->SetShortMasterValue(m_pSong->GetMidiInfo()->GetChannelRef(i+1));
		pSBChan->SetScrollPos(m_pSong->GetMidiInfo()->GetChannel(i+1));
		pSBChan--;
		pChan--;
		m_ppInstName->SetWindowText(m_pSong->GetMidiInfo()->GetName(i+1));
		--m_ppInstName;
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMidiConfig::OnOK()
{
	// TODO: Add extra validation here
	CDialog::OnOK();
}

void CMidiConfig::OnCheckMidiEn1()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En1.GetCheck(),1);	//instrument 1
}

void CMidiConfig::OnCheckMidiEn2()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En2.GetCheck(),2);	//instrument 2

}

void CMidiConfig::OnCheckMidiEn3()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En3.GetCheck(),3);

}

void CMidiConfig::OnCheckMidiEn4()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En4.GetCheck(),4);

}

void CMidiConfig::OnCheckMidiEn5()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En5.GetCheck(),5);

}

void CMidiConfig::OnCheckMidiEn6()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En6.GetCheck(),6);

}

void CMidiConfig::OnCheckMidiEn7()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En7.GetCheck(),7);

}

void CMidiConfig::OnCheckMidiEn8()
{
	// TODO: Add your control notification handler code here
	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En8.GetCheck(),8);

}

void CMidiConfig::OnCheckMidiEn9()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En9.GetCheck(),9);
}

void CMidiConfig::OnCheckMidiEn10()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En10.GetCheck(),10);
}

void CMidiConfig::OnCheckMidiEn11()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En11.GetCheck(),11);
}

void CMidiConfig::OnCheckMidiEn12()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En12.GetCheck(),12);
}

void CMidiConfig::OnCheckMidiEn13()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En13.GetCheck(),13);
}

void CMidiConfig::OnCheckMidiEn14()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En14.GetCheck(),14);
}

void CMidiConfig::OnCheckMidiEn15()
{
	// TODO: Add your control notification handler code here

	CMidiInfo *pMI;

	pMI = this->m_pSong->GetMidiInfo();
	pMI->SetTrackEnable(0,this->m_CheckBox_En15.GetCheck(),15);	//instrent 15
}

LRESULT CMidiConfig::OnChannelChanged(WPARAM chan, LPARAM Inst)
{
//	if(chan == 9)	//channel 10
//	{
		switch(Inst)
		{
			case 1:
				m_SB_Patch1.SetScrollPos(m_SB_Patch1.GetScrollPos());
				break;
			case 2:
				m_SB_Patch2.SetScrollPos(m_SB_Patch2.GetScrollPos());
				break;
			case 3:
				m_SB_Patch3.SetScrollPos(m_SB_Patch3.GetScrollPos());
				break;
			case 4:
				m_SB_Patch4.SetScrollPos(m_SB_Patch4.GetScrollPos());
				break;
			case 5:
				m_SB_Patch5.SetScrollPos(m_SB_Patch5.GetScrollPos());
				break;
			case 6:
				m_SB_Patch6.SetScrollPos(m_SB_Patch6.GetScrollPos());
				break;
			case 7:
				m_SB_Patch7.SetScrollPos(m_SB_Patch7.GetScrollPos());
				break;
			case 8:
				m_SB_Patch8.SetScrollPos(m_SB_Patch8.GetScrollPos());
				break;
			case 9:
				m_SB_Patch9.SetScrollPos(m_SB_Patch9.GetScrollPos());
				break;
			case 10:
				m_SB_Patch10.SetScrollPos(m_SB_Patch10.GetScrollPos());
				break;
			case 11:
				m_SB_Patch11.SetScrollPos(m_SB_Patch11.GetScrollPos());
				break;
			case 12:
				m_SB_Patch12.SetScrollPos(m_SB_Patch12.GetScrollPos());
				break;
			case 13:
				m_SB_Patch13.SetScrollPos(m_SB_Patch13.GetScrollPos());
				break;
			case 14:
				m_SB_Patch14.SetScrollPos(m_SB_Patch14.GetScrollPos());
				break;
			case 15:
				m_SB_Patch15.SetScrollPos(m_SB_Patch15.GetScrollPos());
				break;
		}
//	}
	return 0;
}
