#ifndef CMIDIINFO_H
#define CMIDIINFO_H

#include <stdio.h>
#include "TrackColors.h"

typedef struct {
	char m_InstrumentName[64];
	short m_Patch;
	short m_Channel;
	short m_Range;
	char m_Enable[4];
}TRACK_INFO;

class CMidiInfo
{
	CTrackColors m_Colors[15];
	TRACK_INFO m_tracks[15];
    char m_SongTitle[32];
public:
	void SetInstName(int inst,char *pName);
	void Save(FILE *pO);
    CMidiInfo();
    virtual ~CMidiInfo();
	void Create(void);
	void Create(char *sd);
    void SetInstrument(int instIndex,char *n,unsigned short P,unsigned short C, unsigned short R);
    char *GetName(int inst){return m_tracks[inst-1].m_InstrumentName;}
    inline short GetPatch(int inst){return m_tracks[inst-1].m_Patch;}
	inline short *GetPatchRef(int inst) { return &m_tracks[inst - 1].m_Patch; }
	inline short GetChannel(int inst){return m_tracks[inst-1].m_Channel;}
	inline short *GetChannelRef(int inst) { return &m_tracks[inst - 1].m_Channel; }
	inline short GetRange(int inst){return m_tracks[inst-1].m_Range;}
	inline short *GetRangeRef(int inst) { return &m_tracks[inst - 1].m_Range; }
    char *GetTitle(void){return m_SongTitle;}
    bool IsTrackEnable(int block, int track);
    void SetTrackEnable(int b,unsigned short v, short Inst);
    void SetTitle(char *n);
	CTrackColors *GetInstColor(int Inst){return &m_Colors[Inst-1];}
    void Print(FILE *pO);
protected:
private:
};

#endif // CMIDIINFO_H
