// MsEvent.h: interface for the CMsEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSEVENT_H__97CA41C6_7142_4CE0_B3B2_000F4C771F32__INCLUDED_)
#define AFX_MSEVENT_H__97CA41C6_7142_4CE0_B3B2_000F4C771F32__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "MsObject.h"

extern void SetEventCount(int v);
extern void ResetEventcount(void);

class CMsEvent
{
	short m_Selected;
	CMsEvent *m_pNext;
	CMsEvent *m_pPrev;
	CMsObject * m_EventObjectListHead;
	CMsObject * m_EventObjectListTail;
public:
	int m_Index;
	CMsEvent();
	virtual ~CMsEvent();
	virtual void Draw(CDC *pDC, int event, int maxevent);
	void AddObjectAtStart(CMsObject *pO);
	void AddObjectAtEnd(CMsObject *pO);
	CMsObject *GetHead(void){return m_EventObjectListHead;}
	void SetNext(CMsEvent *pE){m_pNext = pE;}
	CMsEvent *GetNext(void){return m_pNext;}
	void SetPrev(CMsEvent *pE){m_pPrev = pE;}
	CMsEvent *GetPrev(void){return m_pPrev;}
	short IsSelected(void){return m_Selected;}
	void SetSelected(short s){m_Selected = s;}
	int RemoveObject(CMsObject *pObj);
	CMsObject *ObjectAlreadyHere(CMsObject *pObj);
	void Print(FILE *pO);
	// Function returns Note of a given pitch
	CMsNote * FindNote(int Note, int Accidental);
	// Determines if the paricular object is in this event
	CMsObject *ContainsObjectType(int ObjectType);
	int AreObjectsSelected();
	CMsObject * GetFirstSelectedObject();
	CMsObject * GetNextSelectedObject(CMsObject * pLastSelectedObject);
	CMsObject * ContainsRepeatObject();
};

#endif // !defined(AFX_MSEVENT_H__97CA41C6_7142_4CE0_B3B2_000F4C771F32__INCLUDED_)
