// MsObject.h: interface for the CMsObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSOBJECT_H__0E622E5F_84C7_417F_AA5F_D04C9221CD8F__INCLUDED_)
#define AFX_MSOBJECT_H__0E622E5F_84C7_417F_AA5F_D04C9221CD8F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
class CMsBar;
class CMsEnd;
class CMsKeySignature;
class CMsLoudness;
class CMsNote;
class CMsObject;
class CMsRepeatEnd;
class CMsRepeatStart;
class CMsTempo;
class CMsTimeSig;

#define STAVE_OFFSET	64
#define EVENT_WIDTH		24
#define EVENT_OFFSET	32
#define STAVE_HEIGHT	80
#define MAXNOTE_HEIGHT	44	//how high C is above stave
#define HIGHC_OFFSET	20
#define CENTER_OF_TREBEL	(STAVE_OFFSET)
#define CENTER_OF_BASS		(STAVE_OFFSET+48)

union ObjectTypes{
	CMsBar *pBar;
	CMsEnd *pEnd;
	CMsKeySignature *pKey;
	CMsLoudness *pLoud;
	CMsNote *pNote;
	CMsObject *pObj;
	CMsRepeatEnd *pRepE;
	CMsRepeatStart *pRepS;
	CMsTempo *pTemp;
	CMsTimeSig *pTime;
};


enum {
	MSOBJ_BAR,
	MSOBJ_END,
	MSOBJ_KEYSIG,
	MSOBJ_LOUDNESS,
	MSOBJ_NOTE,
	MSOBJ_REPEATEND,
	MSOBJ_REPEATSTART,
	MSOBJ_TEMPO,
	MSOBJ_TIMESIG
};

class CMsObject  
{
	unsigned short m_Selected;
	int m_ObjType;
	CMsObject *m_pNext;
	CMsObject *m_pPrev;
public:
	virtual void Save(FILE *pO);
	virtual CMsObject * Copy(void);
	virtual void Draw(CDC *pDC, int event, int maxevent);
	CMsObject();
	CMsObject(int type);
	virtual ~CMsObject();
	CMsObject* GetNext(void){return m_pNext;}
	void SetNext(CMsObject *pO){m_pNext = pO;}
	void SetPrev(CMsObject *pO){m_pPrev = pO;}
	CMsObject *GetPrev(void){return m_pPrev;}
	virtual void Print(FILE *pO);
	inline void SetType(int t){m_ObjType = t;}
	inline int GetType(void){return m_ObjType;}
	inline void SetSelected(unsigned short s) { m_Selected = s; }
	inline unsigned short IsSelected(void) { return m_Selected; }
};

#endif // !defined(AFX_MSOBJECT_H__0E622E5F_84C7_417F_AA5F_D04C9221CD8F__INCLUDED_)
