// MsRepeatEnd.cpp: implementation of the CMsRepeatEnd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MsRepeatEnd.h"
#include "MsBar.h"
#include "MusicStudioFileFormat.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMsRepeatEnd::CMsRepeatEnd():CMsObject(MSOBJ_REPEATEND)
{

}

CMsRepeatEnd::~CMsRepeatEnd()
{

}

void CMsRepeatEnd::Print(FILE *pO)
{
	fprintf(pO,"Repeat End :|\n");
}

void CMsRepeatEnd::Draw(CDC *pDC, int event, int maxevent)
{
	CPen Light, Heavy, *pOld;
	LOGBRUSH Lb;
	if (IsSelected())
	{
		Light.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
		Lb.lbColor = RGB(255, 0, 0);
	}
	else
	{
		Light.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
		Lb.lbColor = RGB(0, 0, 0);
	}
	Lb.lbStyle = BS_SOLID;
	Lb.lbHatch = 0;

	Heavy.CreatePen(PS_GEOMETRIC | PS_ENDCAP_FLAT,6,&Lb);
	int x = EVENT_OFFSET+EVENT_WIDTH*event+MEASUREBAR_OFFSET;
	pOld = pDC->SelectObject(&Light);
	pDC->MoveTo(x-6,STAVE_OFFSET);
	pDC->LineTo(x-6,STAVE_OFFSET+STAVE_HEIGHT);
	pDC->SelectObject(&Heavy);
	pDC->MoveTo(x,STAVE_OFFSET);
	pDC->LineTo(x,STAVE_OFFSET+STAVE_HEIGHT);
	pDC->SetPixel(x - 8, STAVE_OFFSET + 12, RGB(0, 0, 0));
	pDC->SetPixel(x - 8, STAVE_OFFSET + 20, RGB(0, 0, 0));
	pDC->SetPixel(x - 8, STAVE_OFFSET + 60, RGB(0, 0, 0));
	pDC->SetPixel(x - 8, STAVE_OFFSET + 68, RGB(0, 0, 0));
	pDC->SelectObject(pOld);
}

CMsObject * CMsRepeatEnd::Copy()
{
	CMsObject *pOb = 0;
	CMsRepeatEnd *pRE = new CMsRepeatEnd;
	*pRE = *this;
	pOb = pRE;
	return pOb;
}

void CMsRepeatEnd::Save(FILE *pO)
{
	fputc(TOKEN_REPEAT_STOP,pO);	//token
}
