// MsSong.h: interface for the CMsSong class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSSONG_H__26FEBA33_347B_4586_9D3E_172031FCED31__INCLUDED_)
#define AFX_MSSONG_H__26FEBA33_347B_4586_9D3E_172031FCED31__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MsEvent.h"
#include "MusicStudioFileFormat.h"
#include "EventQueue.h"

#include "MsObject.h"
#include "MidiInfo.h"

class CMsSong
{
	CMsEvent * m_pEventListTail;
	CMsEvent * m_pEventListHead;
	CMidiInfo *m_pMidiInfo;
	CEventQueue *m_pEQ;
public:
	int GetQueueEventTotal(void) { return m_pEQ->GetTotalEvents(); }
	void Save(FILE *pO);
	int m_nTotalEvents;
	CMsNote * CheckForNotePresence(int Event, int Note);
	CWnd * m_pWndParent;
	HMIDIOUT m_hMidiOut;
	CMsEvent *InsertEvent(int e);
	void RenumberEvents(int *First, int *Last);
	void CreateMidiInfo(void);
	int AddObjectToSong(int event,CMsObject *pO);
	virtual void Draw(CDC *pDC, int event, int maxevent,CRect *pRect);
	CMsSong();
	virtual ~CMsSong();
	int Parse(char *pSongData);
	int Play(HMIDIOUT hMo,CWnd *pW,CWnd *pStaffView);
	void Print(FILE *pO);
	CMsEvent * GetEventHead(void);
	CMsEvent *GetEventObject(int Event);
	void AddEventAtStart(CMsEvent *pE);
	void AddEventAtEnd(CMsEvent *pE);
	void CreateMidiInfo(char *pInfo);
	CMidiInfo *GetMidiInfo(void){return m_pMidiInfo;}
    unsigned short LittleEndian(unsigned short bE);
    CEventQueue *GetEventQueue(void){return m_pEQ;}
	// Finds out if there is a note below the cursor
	bool IsNoteInThisEvent(int Note, int Event);
	// Gets a pointer to the note at the given event position
	CMsNote * GetNoteAtEvent(int Note, int Event);
	// Removes an event from the song
	void RemoveEvent(int Event);
	// Delete Event object
	void DeleteEvent(CMsEvent * pEvent);
	// //indicates that the song is playing
	int m_nIsPlaying;
	// Stops the song from playing
	int Stop();
	int IsRepeatInThisEvent(int nEvent);
	CMsObject * GetRepeatObject(int nEvent);
	CMsObject * FindMatchingRepeatObject(CMsObject * pRepeatObject, int nEvent, int * pnMatchingEvent);
	int IsKeySigInThisEvent(int nEvent);
	int IsTimeSigInThisEvent(int nEvent);
	CMsObject * GetObjectTypeInEvent(int nType, int nEvent);
	int IsTempInThisEvent(int nEvent);
	int IsLoudnessInThisEvent(int nEvent);
	CMsObject * IsObjectInEvent(int nEvent, int nObjectType, int &flag);
};

#endif // !defined(AFX_MSSONG_H__26FEBA33_347B_4586_9D3E_172031FCED31__INCLUDED_)
