// MsTempo.cpp: implementation of the CMsTempo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "MsTempo.h"
#include "MusicStudioFileFormat.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMsTempo::CMsTempo():CMsObject(MSOBJ_TEMPO)
{
	m_Tempo = 1;
}

CMsTempo::CMsTempo(int t):CMsObject(MSOBJ_TEMPO)
{
	m_Tempo = t;
}

CMsTempo::~CMsTempo()
{

}

void CMsTempo::Print(FILE *pO)
{
	fprintf(pO,"Tempo:%d\n",m_Tempo);
}

void CMsTempo::Draw(CDC *pDC, int event, int maxevent)
{
	int x,y;
	char *s = new char[16];
	CDC dc;
	CBitmap NoteEq;
	COLORREF OldTextColor;
	int red = 0;

	if (IsSelected()) red = 255;
	OldTextColor = pDC->SetTextColor(RGB(red, 0, 0));
	NoteEq.LoadBitmap(IDB_QUARTERNOTE_EQ);
	dc.CreateCompatibleDC(pDC);
	dc.SelectObject(&NoteEq);
	x = EVENT_OFFSET+EVENT_WIDTH*event;
	y = STAVE_OFFSET-16;
	pDC->BitBlt(x,y-16,16,16,&dc,0,0,SRCCOPY);
	sprintf_s(s,16,"%d",this->m_Tempo);
	pDC->TextOut(x,y,s);
	pDC->SetTextColor(OldTextColor);
	delete[] s;
}

CMsObject * CMsTempo::Copy()
{
	CMsObject *pOb = 0;
	CMsTempo *pRS = new CMsTempo;
	*pRS = *this;
	pOb = pRS;
	return pOb;
}

void CMsTempo::Save(FILE *pO)
{
	fputc(TOKEN_TEMPO,pO);		//token	
	fputc(this->m_Tempo,pO);	//value
}
