// MsTimeSig.cpp: implementation of the CMsTimeSig class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MsTimeSig.h"
#include "MusicStudioFileFormat.h"
#include "MusicStudioPlayer.h"
#include "MsPlayerDlg.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMsTimeSig::CMsTimeSig():CMsObject(MSOBJ_TIMESIG)
{
	m_TimeSig = 0;
}

CMsTimeSig::CMsTimeSig(int ts):CMsObject(MSOBJ_TIMESIG)
{
	m_TimeSig = ts;
}

CMsTimeSig::~CMsTimeSig()
{

}

static char *TimeSigLut[] = {
	"NA",		//0
	"2/2",		//1
	"3/2",		//2
	"2/4",		//3
	"3/4",		//4
	"4/4",		//5
	"5/4",		//6
	"6/8",		//7
	"NA"
};

void CMsTimeSig::Print(FILE *pO)
{
	fprintf(pO,"Time Signature:%s\n",TimeSigLut[m_TimeSig]);
}

void CMsTimeSig::Draw(CDC *pDC, int event, int maxevent)
{
	int x;
	CMSPlayerDlg *pDlg = (CMSPlayerDlg *)theApp.GetMainWnd();
	CDC dc;
	dc.CreateCompatibleDC(pDC);
	x = EVENT_OFFSET+EVENT_WIDTH*event;
	switch(this->m_TimeSig)
	{
		case TIMESIG_2_2:
			dc.SelectObject(&pDlg->m_BmTime22);
			break;
		case TIMESIG_3_2:
			dc.SelectObject(&pDlg->m_BmTime32);
			break;
		case TIMESIG_2_4:
			dc.SelectObject(&pDlg->m_BmTime24);
			break;
		case TIMESIG_3_4:
			dc.SelectObject(&pDlg->m_BmTime34);
			break;
		case TIMESIG_4_4:
			dc.SelectObject(&pDlg->m_BmTime44);
			break;
		case TIMESIG_5_4:
			dc.SelectObject(&pDlg->m_BmTime54);
			break;
		case TIMESIG_6_8:
			dc.SelectObject(&pDlg->m_BmTime68);
			break;
	}
	pDC->BitBlt(x,CENTER_OF_TREBEL,16,33,&dc,0,0,SRCAND);
	pDC->BitBlt(x,CENTER_OF_BASS,16,33,&dc,0,0,SRCAND);
}

CMsObject * CMsTimeSig::Copy()
{
	CMsObject *pOb = 0;
	CMsTimeSig *pTS = new CMsTimeSig;
	*pTS = *this;
	pOb = pTS;
	return pOb;
}

void CMsTimeSig::Save(FILE *pO)
{
	fputc(TOKEN_TIME_SIGNATURE,pO);	//token
	fputc(m_TimeSig,pO);			//value
}
