// StaticPreview.cpp : implementation file
//

#include "stdafx.h"
#include "MusicStudioPlayer.h"
#include "StaticPreview.h"
#include "MsObject.h"
#include "MsBar.h"
#include "MsKeySignature.h"
#include "MsLoudness.h"
#include "MsNote.h"
#include "MsTempo.h"
#include "MsTimeSig.h"
#include "MsRepeatEnd.h"
#include "MsRepeatStart.h"
#include "WindowMessages.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MOUSE_OUTSIDE		0
#define MOUSE_INEDITREG		1
#define MOUSE_INUPPERSEL	2
#define MOUSE_INLOWERSEL	3

/////////////////////////////////////////////////////////////////////////////
// CStaticPreview

CStaticPreview::CStaticPreview()
{
	m_pSong = 0;
	m_pDisp = 0;
	m_MaxEvents = 0;
	m_pDrawObject = 0;
	pLastNote = 0;
	m_MouseInEditRegion = 0;
	m_ExitEditRegion = 0;
	m_lastpitch=0;
	m_LastSelectedEventIndex = -1;
	m_FirstSelectedEvent = -1;
	m_SongScrollPos = 0;
}

CStaticPreview::~CStaticPreview()
{
}


BEGIN_MESSAGE_MAP(CStaticPreview, CStatic)
	//{{AFX_MSG_MAP(CStaticPreview)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_CONTEXTMENU()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DRAWMODE,OnDrawMessage)
	ON_MESSAGE(WM_INIT_STAFF,OnInitStaff)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStaticPreview message handlers

void CStaticPreview::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	

	// TODO: Add your message handler code here
	CRect rect;
	CBrush br(RGB(255,255,255));


	GetClientRect(&rect);
	rect.NormalizeRect();
	dc.FillRect(&rect,&br);
	CPoint Offset = rect.CenterPoint();
	if(m_pSong)
	{
		m_pSong->Draw(&dc,m_SongScrollPos,m_MaxEvents,&rect);
		if(this->m_nDrawMode && this->m_pDrawObject && m_MouseInEditRegion)
		{
			m_pDrawObject->Draw(&dc,m_nDrawEvent-m_SongScrollPos,m_MaxEvents);
		}
	}
	if(m_nDrawMode == DRAWMODE_TIE && m_nDrawState == DRAWSTATE_TIE_SECONDNOTE)
	{
		CRect r;
		r.SetRect(m_TieEndPoint+ CSize(0,-16),m_TieStartPoint + CSize(0,16));
		r.NormalizeRect();
		dc.Arc(r,m_TieStartPoint-CSize(1,0),m_TieEndPoint-CSize(1,0));
	}
	// Do not call CStatic::OnPaint() for painting messages
}

void CStaticPreview::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	char *s = new char[256];
	int event = this->XtoEventIndex(point.x);
	int Note = YtoNote(point.y);

	switch(this->m_nDrawMode)
	{
		case DRAWMODE_NOP:
			break;
		case DRAWMODE_NOTE:
			break;
		case DRAWMODE_BAR:
			break;
	}

	sprintf(s,"x=%d y=%d  EVENT=%d  NOTE=%d",point.x,point.y,event,Note);
	m_pDisp->SetWindowText(s);
	delete[] s;
	CStatic::OnLButtonDown(nFlags, point);
}

void CStaticPreview::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	int Region;
	CMsEvent *pEv;

	m_nDrawEvent = this->XtoEventIndex(point.x);
	Region = this->MouseInRegion(point);
	switch(Region)
	{
		case MOUSE_OUTSIDE:
			break;
		case MOUSE_INUPPERSEL:
		case MOUSE_INLOWERSEL:
			pEv = m_pSong->GetEventObject(m_nDrawEvent);
			if(pEv->IsSelected())	//deselect block
			{
				int i;
				pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
				for(i=m_FirstSelectedEvent;i<m_LastSelectedEventIndex+1;++i)
				{
					pEv->SetSelected(0);
					pEv = pEv->GetNext();
				}
				m_FirstSelectedEvent = -1;
				m_LastSelectedEventIndex = -1;
			}
			else//select events
			{
				if(m_LastSelectedEventIndex >= 0)
				{
					//we are going to select a block
					if(m_FirstSelectedEvent < 0)
					{
						m_FirstSelectedEvent = m_LastSelectedEventIndex;
						m_LastSelectedEventIndex = m_nDrawEvent;
						if(m_LastSelectedEventIndex < m_FirstSelectedEvent)
						{
							int temp = m_LastSelectedEventIndex;
							m_LastSelectedEventIndex = m_FirstSelectedEvent;
							m_FirstSelectedEvent = temp;
						}
						int i;
						pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
						for(i=m_FirstSelectedEvent;i<m_LastSelectedEventIndex+1;++i)
						{
							pEv->SetSelected(1);
							pEv = pEv->GetNext();
						}
					}
					else	//add more events to the block
					{
						if(m_nDrawEvent < m_FirstSelectedEvent)
						{
							pEv = m_pSong->GetEventObject(m_nDrawEvent);
							for(int i=m_nDrawEvent;i<m_FirstSelectedEvent+1;++i)
							{
								pEv->SetSelected(1);
								pEv = pEv->GetNext();
							}
							m_FirstSelectedEvent = m_nDrawEvent;
						}
						else if (m_nDrawEvent > m_LastSelectedEventIndex)
						{
							pEv = m_pSong->GetEventObject(m_LastSelectedEventIndex);
							for(int i=m_LastSelectedEventIndex;i<m_nDrawEvent+1;++i)
							{
								pEv->SetSelected(1);
								pEv = pEv->GetNext();
							}
							m_LastSelectedEventIndex = m_nDrawEvent;
						}
					}
				}
				else
				{
					pEv->SetSelected(1);
					m_LastSelectedEventIndex = m_nDrawEvent;
				}
			}
			Invalidate();
			break;
		case MOUSE_INEDITREG:	
			switch(this->m_nDrawMode)
			{
				case DRAWMODE_NOP:
					break;
				case DRAWMODE_NOTE:
					m_pSong->AddObjectToSong(m_nDrawEvent,m_pDrawObject);
					m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
					{
						CMsNote *pN = new CMsNote;
						CMsNote *pOld = (CMsNote *) m_pDrawObject;
						pOld->m_pEvParent = m_pSong->GetEventObject(m_nDrawEvent);
						//-----------------------------
						// Copy attributes
						//------------------------------
						pN->m_hMidiOut = m_pSong->m_hMidiOut;
						pN->m_pMidiInfo = m_pSong->GetMidiInfo();
						pN->SetDuration(pOld->GetDuration());
						pN->SetPitch(pOld->GetPitch());
						pN->SetAccent(pOld->IsAccent());
						pN->SetKey(pOld->GetKey());
						pN->SetTrack(pOld->GetTrack());
						pN->SetRest(pOld->IsRest());
						pN->SetUpsideDown(pOld->GetUpsideDown());
						m_pDrawObject = pN;
					}
					Invalidate();
					break;
				case DRAWMODE_BAR:
					m_pSong->AddObjectToSong(m_nDrawEvent,m_pDrawObject);
					m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
					{
						CMsBar *pB = new CMsBar;
						m_pDrawObject = pB;
					}
					Invalidate();
					break;
				case DRAWMODE_KKEYSIG:
					m_pSong->AddObjectToSong(m_nDrawEvent,m_pDrawObject);
					m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
					{
						CMsKeySignature *pKS = new CMsKeySignature;
						CMsKeySignature *pOld = (CMsKeySignature *)m_pDrawObject;
						pKS->SetKey(pOld->GetKey());
						m_pDrawObject = pKS;
					}
					Invalidate();
					break;
				case DRAWMODE_TIMESIG:
					m_pSong->AddObjectToSong(m_nDrawEvent,m_pDrawObject);
					m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
					{
						CMsTimeSig *pTS,*pOld;
						pTS = new CMsTimeSig;
						pOld = (CMsTimeSig *)m_pDrawObject;
						pTS->SetTimeSig(pOld->GetTimeSig());
						m_pDrawObject = pTS;
					}
					Invalidate();
					break;
				case DRAWMODE_TIE:
					///-----------------------------------
					/// This is where we change the state of
					/// drawing a tie.  When the mouse releases
					/// we need to check to see if there really
					/// is a note under the mouse pointer.
					///  If there is, record the note and the
					/// points.
					///------------------------------------------
					switch(this->m_nDrawState)
					{
						case DRAWSTATE_TIE_FIRSTNOTE:
							{
								int note = YtoNote(point.y);
								CMsNote *pN = m_pSong->CheckForNotePresence(m_nDrawEvent,note);
								if(pN)
								{
									this->m_pFirstTieNote = pN;
									this->m_nDrawState = DRAWSTATE_TIE_SECONDNOTE;
									this->m_TieStartPoint = point + CSize(0,4);
								}
							}
							break;
						case DRAWSTATE_TIE_SECONDNOTE:
							{
								int note = YtoNote(point.y);
								CMsNote *pN = m_pSong->CheckForNotePresence(m_nDrawEvent,note);
								if(pN)
								{
									this->m_pSecondTieNote = pN;
									this->m_nDrawState = DRAWSTATE_TIE_FIRSTNOTE;
									this->m_TieEndPoint = point + CSize(0,4);
									if(m_TieEndPoint.x > m_TieStartPoint.x)
									{
										m_pFirstTieNote->SetTieBeg(1);
										m_pSecondTieNote->SetTieEnd(1);
									}
									else
									{
										m_pFirstTieNote->SetTieEnd(1);
										m_pSecondTieNote->SetTieBeg(1);
									}
									m_pFirstTieNote = 0;
									m_pSecondTieNote = 0;
									Invalidate();
								}
							}
							break;
					}
					break;
				case DRAWMODE_LOUDNESS:
				case DRAWMODE_TEMPO:
					m_pSong->AddObjectToSong(m_nDrawEvent,m_pDrawObject);
					m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
					m_pDrawObject = 0;
					m_nDrawMode = DRAWMODE_NOP;
					Invalidate();
					break;
				case DRAWMODE_COPY:
					this->CopyBlock(m_nDrawEvent);
					m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
					m_pDrawObject = 0;
					m_nDrawMode = DRAWMODE_NOP;
					Invalidate();
					break;
				case DRAWMODE_MOVE:
					MoveBlock(m_nDrawEvent);
					m_pDrawObject = 0;
					m_nDrawMode = DRAWMODE_NOP;
					Invalidate();
					break;
			}//end of switch(this->m_nDrawMode)
			break;
	}	//end of switch(Region)
	CStatic::OnLButtonUp(nFlags, point);
}

void CStaticPreview::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CMsNote *pN;
	int Region;

	m_nDrawEvent = this->XtoEventIndex(point.x);
	Region = this->MouseInRegion(point);
	switch(Region)
	{
		case MOUSE_INUPPERSEL:
		case MOUSE_INLOWERSEL:
			if(m_MouseInEditRegion)
				m_ExitEditRegion = 1;
			else
				m_ExitEditRegion = 0;
			m_MouseInEditRegion = 0;
			switch(m_nDrawMode)
			{
				case DRAWMODE_NOTE:
					if(m_lastpitch && m_ExitEditRegion)
					{
						pN = (CMsNote *)m_pDrawObject;
						pN->NoteOff(0,m_pKeySig);
						m_lastpitch = 0;
					}
					break;
			}	//end of switch(m_nDrawMode) in case MOUSE_INUPPERSEL
			break;
		case MOUSE_OUTSIDE:
			if(m_MouseInEditRegion)
				m_ExitEditRegion = 1;
			else
				m_ExitEditRegion = 0;
			m_MouseInEditRegion = 0;
			switch(m_nDrawMode)
			{
				case DRAWMODE_NOTE:
					if(m_lastpitch && m_ExitEditRegion)
					{
						pN = (CMsNote *)m_pDrawObject;
						pN->NoteOff(0,m_pKeySig);
						m_lastpitch = 0;
					}
					break;
			}	//end of switch(m_nDrawMode) in case MOUSE_OUTSIDE
			break;
		case MOUSE_INEDITREG:
			m_MouseInEditRegion = 1;
			m_ExitEditRegion = 0;
			switch(this->m_nDrawMode)
			{
				case DRAWMODE_NOTE:
					if(MSOBJ_NOTE == this->m_pDrawObject->GetType())
					{
						pN = (CMsNote *)m_pDrawObject;
						int note = YtoNote(point.y);
						if(m_lastpitch)
						{
							if(m_lastpitch != note)
							{
								pN->NoteOff(0,m_pKeySig);
								pN->SetPitch(note);
								pN->NoteOn(127,m_pKeySig);
								m_lastpitch = note;
							}
						}
						else if(m_lastpitch && m_ExitEditRegion && !m_MouseInEditRegion)
						{
							pN->NoteOff(0,m_pKeySig);
							m_lastpitch = 0;
						}
						else if(!m_lastpitch && m_MouseInEditRegion)
						{
							pN->SetPitch(note);
							pN->NoteOn(127,m_pKeySig);
							m_lastpitch = note;
						}
						Invalidate();
					}
					break;
				case DRAWMODE_BAR:
					if(MSOBJ_BAR == this->m_pDrawObject->GetType())
					{
						Invalidate();
					}
					break;
				case DRAWMODE_KKEYSIG:
				case DRAWMODE_TIMESIG:
				case DRAWMODE_TEMPO:
					Invalidate();
					break;
				case DRAWMODE_TIE:
					switch(this->m_nDrawState)
					{
						case DRAWSTATE_TIE_FIRSTNOTE:
							break;
						case DRAWSTATE_TIE_SECONDNOTE:
							this->m_TieEndPoint = CPoint(point.x,m_TieStartPoint.y);
							Invalidate();
							break;
					}
					break;
				case DRAWMODE_LOUDNESS:
					Invalidate();
					break;
			}
			break;
	}
	CStatic::OnMouseMove(nFlags, point);
}

void CStaticPreview::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CStatic::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CStaticPreview::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	CMsNote *pN;
	switch(nChar)
	{
		case VK_ESCAPE:	//exit draw mode
			switch(m_nDrawMode)
			{
				case DRAWMODE_NOTE:
					if(m_lastpitch)
					{
						pN = (CMsNote *)m_pDrawObject;
						pN->NoteOff(0,m_pKeySig);
						m_lastpitch = 0;
					}
					break;
			}	//end of switch(m_nDrawMode) in case MOUSE_INUPPERSEL
			this->m_nDrawMode = DRAWMODE_NOP;
			delete this->m_pDrawObject;
			m_pDrawObject = 0;
			Invalidate();
			break;
		case VK_SPACE:	//flip note
			if(m_pDrawObject)
			{
				if(m_pDrawObject->GetType() == MSOBJ_NOTE)
				{
					CMsNote *pN = (CMsNote *)m_pDrawObject;
					pN->SetUpsideDown(pN->GetUpsideDown() ^ 1);
					Invalidate();
				}
			}
			break;
		default:
			CStatic::OnKeyUp(nChar, nRepCnt, nFlags);
			break;
}	}


#define ID_CM_INSERTEVEHNT		100
#define ID_CM_DELETEEVENT		101

void CStaticPreview::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
	CMenu ConTexMenu;
	CRect rect;
	GetWindowRect(&rect);
	int Event = this->XtoEventIndex(point.x - rect.left);
	int id;
	ConTexMenu.CreatePopupMenu();
	ConTexMenu.AppendMenu(MF_STRING,ID_CM_INSERTEVEHNT,"Insert Event");
	ConTexMenu.AppendMenu(MF_STRING,ID_CM_DELETEEVENT,"Delete Event");
	id = ConTexMenu.TrackPopupMenu(TPM_RETURNCMD | TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,point.x,point.y, this);
	switch(id)
	{
		case ID_CM_INSERTEVEHNT:
			m_pSong->InsertEvent(Event);
			m_pSong->RenumberEvents();
			Invalidate();
			break;
		case ID_CM_DELETEEVENT:
			break;
	}
}

int NoteLut[7] = {
	0,	//C
	2,	//D
	4,	//E
	5,	//F
	7,	//G
	9,	//A
	11	//B
};

int CStaticPreview::YtoNote(int y)
{
	int r;
	int o = 0;
	//----------------------------
	// Notes place on staff will
	// start at HIGHC_OFFSET and
	// go to HIGHC_OFFSET- 8, so
	// we need to offset this by
	// 4
	//----------------------------
	y -= HIGHC_OFFSET-4;
	y = QuantizeY(y);
	y = 35- y;
	if(y < 0) y = 0;
	r = y % 7;
	int n = NoteLut[r];
	o += (y / 7) * 12;	/// calculate octave
	n = n + o+0x24;
	if(n > 0x60)
		n = 0x60;
	return n;
}

int CStaticPreview::XtoEventIndex(int x)
{
	int ev = x - EVENT_OFFSET;
	int r = ev % EVENT_WIDTH;
	ev /= (int)EVENT_WIDTH;
	if(ev < 0) ev = 0;
	else if (ev >= m_MaxEvents) ev = m_MaxEvents-1;
	return ev + m_SongScrollPos;
}

void CStaticPreview::CalcMaxEvents()
{
	CRect rect;

	GetClientRect(&rect);
	int Width = rect.Width();
	Width -= EVENT_OFFSET;
	m_MaxEvents = Width / EVENT_WIDTH;
}

int CStaticPreview::QuantizeY(int y)
{
	return y / 4;
}

LRESULT CStaticPreview::OnDrawMessage(WPARAM wp, LPARAM lp)
{
	char *s = new char[256];
	int From,To;
	//------------------------
	// Decode sub message
	//------------------------
	switch(wp)
	{
		case DRAW_NOP:
			if(m_pDrawObject) delete m_pDrawObject;
			m_pDrawObject = 0;
			this->m_nDrawMode = DRAWMODE_NOP;
			break;
		case DRAW_NOTE:
			{
				CMsNote *pN = new CMsNote;
				if(m_pDrawObject)
				{
					delete m_pDrawObject;
				}
				m_pDrawObject = pN;
				m_nDrawMode = DRAWMODE_NOTE;
				//-----------------------------
				// decode message word
				//------------------------------
				pN->m_pMidiInfo = m_pSong->GetMidiInfo();
				pN->m_hMidiOut = m_pSong->m_hMidiOut;
				pN->SetDuration(lp & DRAW_NOTE_DURATION);
				pN->SetAccent((lp >> DRAW_NOTE_ACCENT_SHIFT) & 0x01);
				pN->SetKey((lp >> DRAW_NOTE_KEY_SHIFT) & 0x03);
				pN->SetTrack((lp >> DRAW_NOTE_TRACK_SHIFT) & 0x0f);
				pN->SetRest((lp >> DRAW_NOTE_REST_SHIFT) & 1);
				sprintf(s,"Draw Note Message");
				this->m_pDisp->SetWindowText(s);
			}
			break;
		case DRAW_REST:
			break;
		case DRAW_BAR:
			{
				CMsBar *pB = new CMsBar;
				m_nDrawMode = DRAWMODE_BAR;
				m_pDrawObject = pB;
			}
			break;
		case DRAW_TIE:
			if(m_pDrawObject) delete m_pDrawObject;
			m_pDrawObject = 0;
			m_nDrawMode = DRAWMODE_TIE;
			m_nDrawState = DRAWSTATE_TIE_FIRSTNOTE;
			m_pFirstTieNote = 0;
			m_pSecondTieNote = 0;
			break;
		case DRAW_COPY:
			m_nDrawMode = DRAWMODE_COPY;
			break;
		case DRAW_MOVE:
			m_nDrawMode = DRAWMODE_MOVE;
			break;
		case DRAW_REPEAT:
			AddRepeat(lp);
			m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
			Invalidate();
			break;
		case DRAW_TEMPO:
			{
				CMsTempo *pMT = new CMsTempo(lp);
				m_nDrawMode = DRAWMODE_TEMPO;
				m_pDrawObject = pMT;
			}
			break;
		case DRAW_TIMESIG:
			{
				CMsTimeSig *pTS = new CMsTimeSig;
				pTS->SetTimeSig(lp);
				m_nDrawMode = DRAWMODE_TIMESIG;
				m_pDrawObject = pTS;
			}
			break;
		case DRAW_KEYSIG:
			{
				CMsKeySignature *pKS = new CMsKeySignature;
				pKS->SetKey(lp);
				m_nDrawMode = DRAWMODE_KKEYSIG;
				m_pDrawObject = pKS;
			}
			break;
		case DRAW_LOUDNESS:
			{
				CMsLoudness *pLD = new CMsLoudness;
				pLD->SetLoudness(lp);
				m_nDrawMode = DRAWMODE_LOUDNESS;
				m_pDrawObject = pLD;
			}
			break;
		case DRAW_INSTCHANGE:
			From = lp & 0xf;
			To = (lp >> 4) & 0x0f;
			ChangeInst(From,To);
			Invalidate();
			break;
		case DRAW_CHANGEDUR:
			From = lp & 0x1f;
			To = (lp >> 5) & 0x1f;
			ChangeDuration(From,To);
			Invalidate();
			break;
		case DRAW_INCREASEDUR:
			IncreaseDuration();
			break;
		case DRAW_DECREASEDUR:
			break;
		case DRAW_INCRPITCH:
			IncrPitch();
			Invalidate();
			break;
		case DRAW_DECRPITCH:
			DecrPitch();
			Invalidate();
			break;
		case DRAW_INSERTBLOCK:
			InsertBlock();
			m_HScroll.SetScrollRange(0,m_pSong->m_nTotalEvents);
			Invalidate();
			break;
	}
	delete [] s;
	return 0;
}

int CStaticPreview::MouseInRegion(CPoint p)
{
	int rV =MOUSE_OUTSIDE;
	CRect EditRect,rect,UpperSelRect,LowerSelRect;

	GetClientRect(&rect);
	EditRect.SetRect(rect.left+EVENT_OFFSET,rect.top+HIGHC_OFFSET-4,rect.right,rect.top + 162);
	UpperSelRect.SetRect(rect.left+EVENT_OFFSET,rect.top,rect.right,rect.top+HIGHC_OFFSET-3);
	LowerSelRect.SetRect(rect.left+EVENT_OFFSET,rect.top + 162,rect.right,rect.bottom);
	if(EditRect.PtInRect(p)) rV = MOUSE_INEDITREG;
	else if(UpperSelRect.PtInRect(p)) rV = MOUSE_INUPPERSEL;
	else if(LowerSelRect.PtInRect(p)) rV = MOUSE_INLOWERSEL;
	return rV;
}

void CStaticPreview::IncreaseDuration()
{
}

void CStaticPreview::IncrPitch()
{
	if((m_LastSelectedEventIndex < 0) || (m_FirstSelectedEvent < 0))
		MessageBox("No Block Selected","Oppsie");
	else
	{
		CMsEvent *pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
		for(int i=m_FirstSelectedEvent;i<m_LastSelectedEventIndex+1;++i)
		{
			CMsObject *pOb = pEv->GetHead();
			while(pOb)
			{
				if(MSOBJ_NOTE == pOb->GetType())
				{
					CMsNote *pN = (CMsNote *)pOb;
					pN->IncrNote();
				}
				pOb = pOb->GetNext();
			}
			pEv = pEv->GetNext();
		}
	}
}

void CStaticPreview::DecrPitch()
{
	if((m_LastSelectedEventIndex < 0) || (m_FirstSelectedEvent < 0))
		MessageBox("No Block Selected","Oppsie");
	else
	{
		CMsEvent *pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
		for(int i=m_FirstSelectedEvent;i<m_LastSelectedEventIndex+1;++i)
		{
			CMsObject *pOb = pEv->GetHead();
			while(pOb)
			{
				if(MSOBJ_NOTE == pOb->GetType())
				{
					CMsNote *pN = (CMsNote *)pOb;
					pN->DecrNote();
				}
				pOb = pOb->GetNext();
			}
			pEv = pEv->GetNext();
		}
	}
}

void CStaticPreview::InsertBlock()
{
	int i,n;
	n = m_LastSelectedEventIndex-m_FirstSelectedEvent+1;
	for(i=0;i<n;++i)
		m_pSong->InsertEvent(m_FirstSelectedEvent);
	m_pSong->RenumberEvents();
}

void CStaticPreview::AddRepeat(int n)
{
	if(this->m_FirstSelectedEvent < 0 || this->m_LastSelectedEventIndex < 0)
		MessageBox("Block Not Selected","Oopsie");
	else
	{
		///--------------------------------
		/// We add the repeat by adding
		/// a new event before and after
		/// the selected block.
		///---------------------------------
		CMsEvent *pRS,*pRE;
		CMsRepeatStart *pRepStrt;
		CMsRepeatEnd *pRepEnd;

		pRS = m_pSong->InsertEvent(m_FirstSelectedEvent);
		m_pSong->RenumberEvents();
		m_LastSelectedEventIndex++;
		pRE = m_pSong->InsertEvent(m_LastSelectedEventIndex + 1);
		m_pSong->RenumberEvents();
		pRepStrt = new CMsRepeatStart(n);
		pRepEnd = new CMsRepeatEnd;
		pRS->AddObjectAtStart(pRepStrt);
		pRE->AddObjectAtStart(pRepEnd);
	}
}

void CStaticPreview::ChangeInst(int From, int To)
{
	if((m_LastSelectedEventIndex < 0) || (m_FirstSelectedEvent < 0))
		MessageBox("No Block Selected","Oppsie");
	else
	{
		CMsEvent *pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
		for(int i=m_FirstSelectedEvent;i<m_LastSelectedEventIndex+1;++i)
		{
			CMsObject *pOb = pEv->GetHead();
			while(pOb)
			{
				if(MSOBJ_NOTE == pOb->GetType())
				{
					CMsNote *pN = (CMsNote *)pOb;
					if(pN->GetTrack() == (unsigned)From)
						pN->SetTrack(To);
				}
				pOb = pOb->GetNext();
			}
			pEv = pEv->GetNext();
		}
	}
}

void CStaticPreview::ChangeDuration(int From, int To)
{
	if((m_LastSelectedEventIndex < 0) || (m_FirstSelectedEvent < 0))
		MessageBox("No Block Selected","Oppsie");
	else
	{
		CMsEvent *pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
		for(int i=m_FirstSelectedEvent;i<m_LastSelectedEventIndex+1;++i)
		{
			CMsObject *pOb = pEv->GetHead();
			while(pOb)
			{
				if(MSOBJ_NOTE == pOb->GetType())
				{
					CMsNote *pN = (CMsNote *)pOb;
					if(pN->GetDuration() == From)
						pN->SetDuration(To);
				}
				pOb = pOb->GetNext();
			}
			pEv = pEv->GetNext();
		}
	}
}

void CStaticPreview::CopyBlock(int dest)
{
	//-------------------------------
	// first thing, copy the block
	//-------------------------------
	CMsEvent *pHead=0,*pTail=0;
	CMsEvent *pEv,*pEvNew;

	if((m_LastSelectedEventIndex < 0) || (m_FirstSelectedEvent < 0))
		MessageBox("No Block Selected","Oppsie");
	else
	{
		pEv = m_pSong->GetEventObject(m_FirstSelectedEvent);
		while(pEv->m_Index != m_LastSelectedEventIndex+1)
		{
			CMsObject *pOb;
			pEvNew = new CMsEvent;
			pOb = pEv->GetHead();
			while(pOb)
			{
				CMsObject *pNewObj;
				pNewObj = pOb->Copy();
				pNewObj->SetNext(0);
				pNewObj->SetPrev(0);
				pEvNew->AddObjectAtEnd(pNewObj);
				pOb = pOb->GetNext();
			}
			if(pHead == 0)
			{
				pHead = pEvNew;
				pTail = pEvNew;
			}
			else
			{
				pTail->SetNext(pEvNew);
				pEvNew->SetPrev(pTail);
				pTail = pEvNew;
			}
			pEv = pEv->GetNext();
		}
		///--------------------------------
		/// Chain is created.  Now, insert
		/// into the song at the desired
		/// spot
		///--------------------------------
		CMsEvent *pDest = m_pSong->GetEventObject(dest);
		pTail->SetNext(pDest->GetNext());
		pDest->SetNext(pHead);
		pHead->SetPrev(pDest->GetPrev());
		pTail->GetNext()->SetPrev(pTail);
	}
	m_pSong->RenumberEvents();
}

void CStaticPreview::MoveBlock(int dest)
{
	CMsEvent *pHead=0,*pTail=0,*pDest=0;
	CMsEvent *pEv;

	///--------------------------
	/// snip out block
	///----------------------------
	if((m_LastSelectedEventIndex < 0) || (m_FirstSelectedEvent < 0))
		MessageBox("No Block Selected","Oppsie");
	else
	{
		pDest = m_pSong->GetEventObject(dest);
		pHead = m_pSong->GetEventObject(m_FirstSelectedEvent);
		pTail = m_pSong->GetEventObject(m_LastSelectedEventIndex);
		pEv = pHead->GetPrev();
		pEv->SetNext(pTail->GetNext());
		pEv->GetNext()->SetPrev(pEv);
		pHead->SetPrev(0);
		pTail->SetNext(0);
		///--------------------------------
		/// Chain is created.  Now, insert
		/// into the song at the desired
		/// spot
		///--------------------------------
		pTail->SetNext(pDest->GetNext());
		pDest->SetNext(pHead);
		pHead->SetPrev(pDest->GetPrev());
		pTail->GetNext()->SetPrev(pTail);
		m_pSong->RenumberEvents();
		pEv = pHead;
		while(pEv != pTail)
		{
			pEv->SetSelected(0);
			pEv = pEv->GetNext();
		}
		pEv->SetSelected(0);
		m_FirstSelectedEvent = -1;
		m_LastSelectedEventIndex = -1;
	}
}

LRESULT CStaticPreview::OnInitStaff(WPARAM wp, LPARAM lp)
{
//	ShowScrollBar(SB_HORZ);
//	SetScrollRange(SB_HORZ,0,20);
//	SetScrollPos(SB_HORZ,2);
//	this->EnableScrollBar(SB_HORZ,ESB_ENABLE_BOTH);
	return 0;
}

BOOL CStaticPreview::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
//	cs.style |= WS_HSCROLL;
	return CStatic::PreCreateWindow(cs);
}

void CStaticPreview::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	m_SongScrollPos = m_HScroll.GetScrollPos();
	switch(nSBCode)
	{
		case SB_LINELEFT:
			m_SongScrollPos--;
			if(m_SongScrollPos < 0) m_SongScrollPos = 0;
			m_HScroll.SetScrollPos(m_SongScrollPos);
			break;
		case SB_LINERIGHT:
			m_SongScrollPos++;
			if(m_SongScrollPos > m_pSong->m_nTotalEvents) m_SongScrollPos =  m_pSong->m_nTotalEvents;
			m_HScroll.SetScrollPos(m_SongScrollPos);
			break;
		case SB_PAGELEFT:
			m_SongScrollPos -=10;
			if(m_SongScrollPos > m_pSong->m_nTotalEvents) m_SongScrollPos =  m_pSong->m_nTotalEvents;
			m_HScroll.SetScrollPos(m_SongScrollPos);
			break;
		case SB_PAGERIGHT:
			m_SongScrollPos += 10;
			if(m_SongScrollPos > m_pSong->m_nTotalEvents) m_SongScrollPos =  m_pSong->m_nTotalEvents;
			m_HScroll.SetScrollPos(m_SongScrollPos);
			break;
		case SB_THUMBTRACK:
			m_SongScrollPos = nPos;
			m_HScroll.SetScrollPos(nPos);
			break;
	}
	Invalidate();
	CStatic::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CStaticPreview::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	UINT uiHHeight = GetSystemMetrics(SM_CYHSCROLL);
	UINT uiVWidth = GetSystemMetrics(SM_CXVSCROLL);
	CRect rectClient, rectH, rectV;
	GetClientRect(rectClient);
	rectH = rectClient;
	rectH.top = rectH.bottom - uiHHeight;
	rectH.right -= uiVWidth;

	m_HScroll.Create(SBS_HORZ | SBS_BOTTOMALIGN | WS_CHILD | WS_VISIBLE, rectH, this, 1100);

	SCROLLINFO sci;
	memset(&sci, 0, sizeof(sci));

	sci.cbSize = sizeof(SCROLLINFO);
	sci.fMask = SIF_ALL;
	sci.nMax = 1000;
	sci.nPage = 200;

	m_HScroll.SetScrollInfo(&sci, TRUE);
//	m_HScroll.ShowWindow(false);
	CStatic::PreSubclassWindow();
}

BOOL CStaticPreview::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CStatic::PreTranslateMessage(pMsg);
}
