#if !defined(AFX_STATICPREVIEW_H__5C700A14_0191_4CE9_B36F_D5F0B59B0E95__INCLUDED_)
#define AFX_STATICPREVIEW_H__5C700A14_0191_4CE9_B36F_D5F0B59B0E95__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StaticPreview.h : header file
//

#include "MsObject.h"
#include "MsSong.h"
#include "DisplayStatic.h"

/////////////////////////////////////////////////////////////////////////////
// CStaticPreview window
#define DRAWMODE_NOP		0
#define DRAWMODE_NOTE		1
#define DRAWMODE_BAR		2
#define DRAWMODE_KKEYSIG	3
#define DRAWMODE_TIMESIG	4
#define DRAWMODE_TIE		5
#define DRAWMODE_LOUDNESS	6
#define DRAWMODE_TEMPO		7
#define DRAWMODE_COPY		8
#define DRAWMODE_MOVE		9

///-------------------------------
/// States for DRAWMODE_TIE
///-------------------------------

#define DRAWSTATE_TIE_FIRSTNOTE		0
#define DRAWSTATE_TIE_SECONDNOTE	1

class CStaticPreview : public CStatic
{
	int m_SongScrollPos;
// Construction
public:
	CStaticPreview();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticPreview)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	CScrollBar m_HScroll;
	void MoveBlock(int dest);
	void CopyBlock(int dest);
	void ChangeDuration(int From, int To);
	void ChangeInst(int From, int To);
	void AddRepeat(int n);
	void InsertBlock(void);
	void DecrPitch();
	void IncrPitch(void);
	void IncreaseDuration(void);
	int m_FirstSelectedEvent;
	int m_LastSelectedEventIndex;
	int MouseInRegion(CPoint p);
	CMsKeySignature * m_pKeySig;
	CPoint m_TieEndPoint;
	CPoint m_TieStartPoint;
	CMsNote * m_pSecondTieNote;
	CMsNote * m_pFirstTieNote;
	int m_nDrawState;
	int m_ExitEditRegion;
	int m_lastpitch;
	HMIDIOUT m_hMidiOut;
	int m_MouseInEditRegion;
	CMsNote *pLastNote;
	int m_nDrawEvent;
	CMsObject * m_pDrawObject;
	int m_nDrawMode;
	int QuantizeY(int y);
	void CalcMaxEvents(void);
	int m_MaxEvents;
	int XtoEventIndex(int x);
	int YtoNote(int y);
	CDisplayStatic * m_pDisp;
	CMsSong * m_pSong;
	virtual ~CStaticPreview();

	// Generated message map functions
protected:
	LRESULT OnInitStaff(WPARAM wp, LPARAM lp);
	LRESULT OnDrawMessage(WPARAM wp, LPARAM lp);
	//{{AFX_MSG(CStaticPreview)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STATICPREVIEW_H__5C700A14_0191_4CE9_B36F_D5F0B59B0E95__INCLUDED_)
